# Pygame шаблон - скелет для нового проекта Pygame

import pygame
from pygame import *
from random import *
import os

# Объявляем переменные

WIN_WIDTH = 480  # Ширина создаваемого окна
WIN_HEIGHT = 416  # Высота
DISPLAY = (WIN_WIDTH, WIN_HEIGHT)  # Группируем ширину и высоту в одну переменную

FPS = 30
# Задаем цвета
WHITE = (255, 255, 255)
BLACK = (0, 0, 0)
RED = (255, 0, 0)
GREEN = (0, 255, 0)
BLUE = (0, 0, 255)
BACKGROUND_COLOR = "#004400"

(DIR_UP, DIR_RIGHT, DIR_DOWN, DIR_LEFT) = range(4)
STOP = 4

(OWNER_PLAYER, OWNER_ENEMY) = range(2)

(BONUS_GRENADE, BONUS_HELMET, BONUS_SHOVEL, BONUS_STAR, BONUS_TANK, BONUS_TIMER) = range(6)

(TILE_EMPTY, TILE_BRICK, TILE_STEEL, TILE_WATER, TILE_GRASS, TILE_FROZE) = range(6)

TILE_SIZE = 16


# Точка спауна
class Spawn:
    def __init__(self, das, fad):
        # Обращаемся к глобальной переменной sprites
        global sprites

        # spawn 1
        self.img_undamaged = sprites.subsurface(68, 100, 26, 27)
        # spawn 2
        self.img_destroyed = sprites.subsurface(98, 98, 27, 27)
        # Определяем позицию ректангла, она всегда постоянная
        self.rect = pygame.Rect(das, fad, 32, 32)

    def draw(self, sad):
        """ Здесь рисуем наш взрыв """
        global screen
        if sad == 1:
            screen.blit(self.img_undamaged, self.rect.topleft)
        if sad == 2:
            screen.blit(self.img_destroyed, self.rect.topleft)


class Tank:
    def __init__(self, speed):
        self.img_ = sprites.subsurface(16 * 2, 0, 16 * 2, 16 * 2).convert_alpha()
        self.image_up = self.img_
        self.image_left = pygame.transform.rotate(self.img_, 90)
        self.image_down = pygame.transform.rotate(self.img_, 180)
        self.image_right = pygame.transform.rotate(self.img_, 270)
        self.speed = speed

    def draw(self):
        """ Здесь рисуем наш танк """
        global screen

        screen.blit(self.img_, self.rect.topleft)

    def GiveAmplifiers(self):
        pass

    def move_right(self, speed):
        self.rect = self.rect.update(1 * speed, 0)
        screen.blit(self.image_right, self.rect.topleft)

    def move_left(self, speed):
        self.rect = self.rect.update(-1 * speed, 0)
        screen.blit(self.image_left, self.rect.topleft)

    def move_up(self, speed):
        self.rect = self.rect.update(0, -1 * speed)
        screen.blit(self.img_, self.rect.topleft)

    def move_down(self, speed):
        self.rect = self.rect.update(0, 1 * speed)
        screen.blit(self.image_down, self.rect.topleft)

    def strike(self, speed_bullet, bullet, down, left, right, up):
        das = self.rect[0]
        fad = self.rect[1]
        if up:
            bullet.rect = pygame.Rect(das + 5, fad, 6, 10)
            while True:
                bullet.rect = bullet.rect.move(0, -3 * speed_bullet)
                bullet.draw(2)
                pygame.display.update()
        elif down:
            bullet.rect = pygame.Rect(das + 12, fad + 30, 6, 10)
            while True:
                bullet.rect = bullet.rect.move(0, 3 * speed_bullet)
                bullet.draw(3)
                pygame.display.update()
        elif left:
            bullet.rect = pygame.Rect(das - 23, fad + 18, 6, 10)
            while True:
                bullet.rect = bullet.rect.move(-3 * speed_bullet, 0)
                bullet.draw(2)
                pygame.display.update()
        elif right:
            bullet.rect = pygame.Rect(das + 23, fad + 10, 6, 10)
            while True:
                bullet.rect = bullet.rect.move(3 * speed_bullet, 0)
                bullet.draw(4)
                pygame.display.update()
        else:
            bullet.rect = pygame.Rect(das + 5, fad, 6, 10)
            while True:
                bullet.rect = bullet.rect.move(0, -3 * speed_bullet)
                bullet.draw(1)
                pygame.display.update()

    def Destroy(self):
        pass


class Player:
    """ Player """

    def __init__(self, color0, das, fad, health=1):
        super().__init__()
        # Обращаемся к глобальной переменной sprites
        global sprites

        # Задаём рисунок танка
        self.img_ = sprites.subsurface(0, 0, 13 * 2, 13 * 2).convert_alpha()
        self.speed = 3
        self.health = health
        self.bullet_speed = 5
        self.bullets_power = 1
        self.player_bullets = []
        self.ColorImage = color0
        # Задаём рисунок танка в разных направлениях
        self.image_up = self.img_

        self.colorImage = pygame.Surface(self.img_.get_size())
        self.colorImage.fill(self.ColorImage)
        self.img_.blit(self.colorImage, pygame.Rect(0, 0, 15 * 2, 15 * 2), special_flags=pygame.BLEND_RGBA_MULT)

        self.image_left = pygame.transform.rotate(self.img_, 90)
        self.image_down = pygame.transform.rotate(self.img_, 180)
        self.image_right = pygame.transform.rotate(self.img_, 270)
        self.direction = DIR_UP

        # Определяем позицию ректангла
        self.rect = pygame.Rect(das, fad, 32, 32)

    def draw(self):
        """ Здесь рисуем наш танк """
        global screen
        screen.blit(self.img_, self.rect.topleft)

    def GiveAmplifiers2(self, amplifier):
        global players, enemies, stop, shield0, star, steel, sto, das1, fad1, sad1, die

        if amplifier.bonus == 0:
            die = True

        if amplifier.bonus == 1:
            shield0 = True

        if amplifier.bonus == 2:
            for castle in castles:
                Level0.mapr.append(myRect(castle.rect[0] - 16, castle.rect[1], 8, 8, TILE_STEEL))
                Level0.mapr.append(myRect(castle.rect[0] - 16, castle.rect[1] + 16, 8, 8, TILE_STEEL))
                Level0.mapr.append(myRect(castle.rect[0] - 16, castle.rect[1] - 16, 8, 8, TILE_STEEL))

                Level0.mapr.append(myRect(castle.rect[0] + 32, castle.rect[1], 8, 8, TILE_STEEL))
                Level0.mapr.append(myRect(castle.rect[0] + 32, castle.rect[1] + 16, 8, 8, TILE_STEEL))
                Level0.mapr.append(myRect(castle.rect[0] + 32, castle.rect[1] - 16, 8, 8, TILE_STEEL))

                Level0.mapr.append(myRect(castle.rect[0] + 16, castle.rect[1] - 16, 8, 8, TILE_STEEL))
                Level0.mapr.append(myRect(castle.rect[0], castle.rect[1] - 16, 8, 8, TILE_STEEL))
            steel = True

        if amplifier.bonus == 3:
            star += 1

        if amplifier.bonus == 5:
            stop = True
            sto = 300

        if amplifier.bonus == 4:
            if das1 - 500 < 0:
                self.health += 1
                player_health.append(Player_health(das1, fad1))
                das1 += 18
                sad1 += 1
            if das1 - 500 >= 0:
                das1 = 425

        amplifiers.remove(amplifier)
        #     if amplifier.bonus == 0:
        #         for player in players:
        #             players.remove(player)
        #
        #     if amplifier.bonus == 5:
        #         pass

    def update(self, direction):
        """ Двигаем танк """
        global enemies, labels, water_blocks, iron_blocks, players
        if direction == DIR_RIGHT:
            new_position = [self.rect.left + self.speed, self.rect.top]
            self.img_ = self.image_right
            self.direction = DIR_RIGHT
            if new_position[0] > (416 - 26):
                return
        elif direction == DIR_LEFT:
            new_position = [self.rect.left - self.speed, self.rect.top]
            self.img_ = self.image_left
            self.direction = DIR_LEFT
            if new_position[0] < 0:
                return
        elif direction == DIR_UP:
            new_position = [self.rect.left, self.rect.top - self.speed]
            self.img_ = self.image_up
            self.direction = DIR_UP
            if new_position[1] < 0:
                return
        elif direction == DIR_DOWN:
            new_position = [self.rect.left, self.rect.top + self.speed]
            self.img_ = self.image_down
            self.direction = DIR_DOWN
            if new_position[1] > (416 - 26):
                return
        else:
            return

        new_rect = pygame.Rect(new_position, [13 * 2, 13 * 2])

        # Коллизии с врагами
        for enemy in enemies:
            # if new_rect.colliderect(enemy.rect):
            #     return

            # Коллизии с Tile'ми

            # for map in Level0.mapr:
            rects = Level0.obstacle_rects
            collisions = new_rect.collidelistall(rects)
            if collisions:
                return

        for amplifier in amplifiers:
            if new_rect.colliderect(amplifier.rect):
                self.GiveAmplifiers2(amplifier)
                sounds["bonus"].play()
        # Делаем новое значение положения игрока
        self.rect.topleft = (new_position[0], new_position[1])
        return True

    def fire(self):
        global bullets
        if not self.player_bullets:
            self.player_bullets.append(
                Bullet(self.rect.topleft, self.direction, OWNER_PLAYER, self.bullets_power, self.bullet_speed))
        # TODO


class EnemyTank(Tank):
    def __init__(self, das, fad, color1, speed, sad):
        super().__init__(speed)
        # Обращаемся к глобальной переменной sprites
        global sprites
        self.sad = sad
        self.color1 = color1
        self.direction = DIR_UP
        self.s = 0
        self.bullet_speed = 5
        self.bullets_power = 1
        self.enemy_bullets = []
        self.a = 2
        if sad == 1:
            self.img_ = sprites.subsurface(32 * 2, 0, 15 * 2, 15 * 2).convert_alpha()
            self.health = 1
        if sad == 2:
            self.img_ = sprites.subsurface(48 * 2, 0, 15 * 2, 15 * 2).convert_alpha()
            self.health = 1
        if sad == 3:
            self.img_ = sprites.subsurface(64 * 2, 0, 15 * 2, 15 * 2).convert_alpha()
            self.health = 1
            self.speed = speed + 1
        if sad == 4:
            self.img_ = sprites.subsurface(80 * 2, 0, 15 * 2, 15 * 2).convert_alpha()
            self.health = 4
        if sad == 5:
            self.img_ = sprites.subsurface(32 * 2, 30, 15 * 2, 15 * 2).convert_alpha()
            self.health = 1
        if sad == 6:
            self.img_ = sprites.subsurface(48 * 2, 30, 15 * 2, 15 * 2).convert_alpha()
            self.health = 1
        if sad == 7:
            self.img_ = sprites.subsurface(64 * 2, 30, 15 * 2, 15 * 2).convert_alpha()
            self.health = 1
        if sad == 8:
            self.img_ = sprites.subsurface(80 * 2, 30, 15 * 2, 15 * 2).convert_alpha()
            self.health = 4

        self.health0 = self.health
        self.bullet = True
        # Определяем позицию ректангла, она всегда постоянная
        self.colorImage = pygame.Surface(self.img_.get_size())
        self.colorImage.fill(color1)

        # Определяем позицию ректангла
        self.rect = pygame.Rect(das, fad, 28, 32)
        self.img_.blit(self.colorImage, pygame.Rect(0, 0, 15 * 2, 15 * 2), special_flags=pygame.BLEND_RGBA_MULT)
        self.image_up = self.img_
        self.image_left = pygame.transform.rotate(self.img_, 90)
        self.image_down = pygame.transform.rotate(self.img_, 180)
        self.image_right = pygame.transform.rotate(self.img_, 270)

    def update(self, direction):
        """ Двигаем танк """

        global enemies, labels, water_blocks, iron_blocks, players
        if direction == DIR_RIGHT and self.s > 0:
            new_position = [self.rect.left + self.speed, self.rect.top]
            self.img_ = self.image_right
            self.direction = DIR_RIGHT
            if new_position[0] > (416 - 26):
                self.s = 0
                return
            self.s -= 1
        elif direction == DIR_LEFT and self.s > 0:
            new_position = [self.rect.left - self.speed, self.rect.top]
            self.img_ = self.image_left
            self.direction = DIR_LEFT
            if new_position[0] < 0:
                self.s = 0
                return
            self.s -= 1
        elif direction == DIR_UP and self.s > 0:
            new_position = [self.rect.left, self.rect.top - self.speed]
            self.img_ = self.image_up
            self.direction = DIR_UP
            if new_position[1] < 0:
                self.s = 0
                return
            self.s -= 1
        elif direction == DIR_DOWN and self.s > 0:
            new_position = [self.rect.left, self.rect.top + self.speed]
            self.img_ = self.image_down
            self.direction = DIR_DOWN
            if new_position[1] > (416 - 26):
                self.s = 0
                return
            self.s -= 1

        elif direction == 5 and self.speed != 0:
            self.fire()
            new_position = [self.rect.left, self.rect.top]
            self.s = 0
        else:
            new_position = [self.rect.left, self.rect.top]
            self.s = 0
            self.a = 0

        new_rect = pygame.Rect(new_position, [13 * 2, 13 * 2])
        # Коллизии с врагами
        for playe in players:
            # if new_rect.colliderect(playe.rect):
            #     return

            # Коллизии с Tile'ми

            # for map in Level0.mapr:
            rects = Level0.obstacle_rects
            collisions = new_rect.collidelistall(rects)
            if collisions:
                self.s = 0
                return

        # for amplifier in amplifiers:
        #     if new_rect.colliderect(amplifier.rect):
        #         self.GiveAmplifiers2(amplifier)
        # Делаем новое значение положения игрока
        self.rect.topleft = (new_position[0], new_position[1])

        return True

    def colors(self):
        if self.health != self.health0 and self.bullet:
            self.colorImage = pygame.Surface(self.img_.get_size())

            if self.health == 3:
                self.colorImage.fill((155, 255, 255))

            if self.health == 2:
                self.colorImage.fill((255, 155, 255))

            if self.health == 1:
                self.colorImage.fill((255, 255, 155))

            self.image_up.blit(self.colorImage, pygame.Rect(0, 0, 15 * 2, 15 * 2), special_flags=pygame.BLEND_RGBA_MULT)
            self.image_left = pygame.transform.rotate(self.image_up, 90)
            self.image_down = pygame.transform.rotate(self.image_up, 180)
            self.image_right = pygame.transform.rotate(self.image_up, 270)
            self.bullet = False

    def draw(self):
        """ Здесь рисуем наш танк """
        global screen
        if self.sad != 4 and self.sad != 8:
            screen.blit(self.img_, self.rect.topleft)
        else:
            self.colors()
            screen.blit(self.img_, self.rect.topleft)

    def fire(self):
        if not self.enemy_bullets:
            self.enemy_bullets.append(
                Bullet(self.rect.topleft, self.direction, OWNER_ENEMY, self.bullets_power, self.bullet_speed))
        # TODO


class Babaxs:
    def __init__(self, das, fad, sad, health=5):
        # Обращаемся к глобальной переменной sprites
        global sprites

        self.health = health
        # маленький взрыв
        if sad == 1:
            self.img_ = sprites.subsurface(20, 140, 20, 83)
        # средний взрыв
        if sad == 2:
            self.img_ = sprites.subsurface(80, 180, 30, 40)
        # большой взрыв
        if sad == 3:
            self.img_ = sprites.subsurface(120, 160, 70, 60)

        self.rect = pygame.Rect(das, fad, 30, 36)

    def draw(self):
        """ Здесь рисуем наш взрыв """
        global screen
        screen.blit(self.img_, self.rect.topleft)


class EnemyBabax(Babaxs):
    def __init__(self, das, fad, sad, health=9):
        super().__init__(das, fad, sad, health)

    def update(self, health):
        if health == 9:
            self.img_ = sprites.subsurface(80, 180, 30, 40)

        elif health == 3:
            self.img_ = sprites.subsurface(120, 160, 70, 60)
            self.rect = pygame.Rect(self.rect[0] - 30, self.rect[1] - 20, 70, 60)


class Shild:
    def __init__(self, das, fad, sad):
        # Обращаемся к глобальной переменной sprites
        global sprites

        # щит 1
        if sad == 1:
            self.img_undamaged = sprites.subsurface(0, 95, 32, 33)
        # щит 2
        if sad == 2:
            self.img_undamaged = sprites.subsurface(32, 95, 32, 33)
        # Определяем позицию ректангла, она всегда постоянная
        self.sad = sad
        self.rect = pygame.Rect(das, fad, 32, 33)

    def draw(self):
        """ Здесь рисуем наш взрыв """
        global screen
        screen.blit(self.img_undamaged, self.rect.topleft)

    def update(self):
        self.sad += 1
        if self.sad == 10:
            self.img_undamaged = sprites.subsurface(32, 95, 32, 33)
        if self.sad == 20:
            self.img_undamaged = sprites.subsurface(0, 95, 32, 33)
            self.sad = 1


class Back_ground_grey:
    def __init__(self, das, fad):
        # Обращаемся к глобальной переменной sprites
        global sprites
        self.img_undamaged = sprites1.subsurface(0, 50, 65, 500).convert_alpha()
        self.colorImage = pygame.Surface(self.img_undamaged.get_size())
        self.colorImage.fill((255, 255, 255))
        self.img_undamaged.blit(self.colorImage, pygame.Rect(0, 0, 15 * 2, 15 * 2),
                                special_flags=pygame.BLEND_RGBA_MULT)
        self.rect = pygame.Rect(das, fad, 32, 33)

    def draw(self):
        """ Здесь рисуем наш взрыв """
        global screen
        screen.blit(self.img_undamaged, self.rect.topleft)


class Enemy_health:
    def __init__(self, das, fad):
        # Обращаемся к глобальной переменной sprites
        global sprites
        self.img_undamaged = sprites.subsurface(160, 110, 18, 18).convert_alpha()
        self.rect = pygame.Rect(das, fad, 32, 33)

    def draw(self):
        """ Здесь рисуем наш взрыв """
        global screen
        screen.blit(self.img_undamaged, self.rect.topleft)


class Player_health:
    def __init__(self, das, fad):
        # Обращаемся к глобальной переменной sprites
        global sprites
        self.img_undamaged = sprites.subsurface(177, 110, 15, 18).convert_alpha()
        self.rect = pygame.Rect(das, fad, 32, 33)

    def draw(self):
        """ Здесь рисуем наш взрыв """
        global screen
        screen.blit(self.img_undamaged, self.rect.topleft)


class Flag:
    def __init__(self, das, fad, sad):
        # Обращаемся к глобальной переменной sprites
        global sprites
        self.img_undamaged = sprites.subsurface(129, 98, 33, 30).convert_alpha()
        self.rect = pygame.Rect(das, fad, 32, 33)
        self.sad = sad

    def draw(self):
        """ Здесь рисуем наш взрыв """
        global screen
        screen.blit(self.img_undamaged, self.rect.topleft)

    def collidepoint(self, x, y):
        return self.rect.collidepoint(x, y)


class textAria:
    def __init__(self, x, y, w, h, color):
        self.rect = pygame.Rect(x, y, w, h)
        self.color = color

    def set_text(self, text, text_color):
        self.text = font1.render(text, True, text_color)
        self.text0 = text

    def draw(self):
        # pygame.draw.rect(bg, self.color, self.rect)
        screen.blit(self.text, self.rect)

    def collidepoint(self, x, y):
        return self.rect.collidepoint(x, y)


class Bonus:

    def __init__(self):
        global sprites

        self.active = True

        self.visible = True
        self.visible_clock = 10
        self.visible_clock_timer = self.visible_clock

        self.rect = pygame.Rect(randint(0, 416 - 32), randint(0, 416 - 32), 32, 32)

        self.bonus = choice([
            BONUS_GRENADE,
            BONUS_HELMET,
            BONUS_SHOVEL,
            BONUS_STAR,
            BONUS_TANK,
            BONUS_TIMER
        ])

        self.image = sprites.subsurface(16 * 2 * self.bonus, 32 * 2, 16 * 2, 15 * 2)

    def draw(self):
        global screen
        if self.visible:
            screen.blit(self.image, self.rect.topleft)
        if self.visible_clock_timer > 0:
            self.visible_clock_timer = self.visible_clock_timer - 1
        elif self.visible_clock_timer <= 0:
            self.toggleVisibility()
            self.visible_clock_timer = self.visible_clock

    def toggleVisibility(self):
        self.visible = not self.visible


class Bullet:
    (STATE_REMOVED, STATE_ACTIVE, STATE_EXPLODING) = range(3)

    def __init__(self, position, direction, owner, power, speed=5):

        global sprites

        self.power = power
        self.speed = speed
        self.direction = direction
        self.owner = owner
        self.image = sprites.subsurface(75 * 2, 74 * 2, 3 * 2, 4 * 2)

        if direction == DIR_UP:
            self.rect = pygame.Rect(position[0] + 11, position[1] - 8, 6, 8)
        elif direction == DIR_RIGHT:
            self.image = pygame.transform.rotate(self.image, 270)
            self.rect = pygame.Rect(position[0] + 26, position[1] + 11, 8, 6)
        elif direction == DIR_DOWN:
            self.image = pygame.transform.rotate(self.image, 180)
            self.rect = pygame.Rect(position[0] + 11, position[1] + 26, 6, 8)
        elif direction == DIR_LEFT:
            self.image = pygame.transform.rotate(self.image, 90)
            self.rect = pygame.Rect(position[0] - 8, position[1] + 11, 8, 6)

        self.explosion_images = [
            sprites.subsurface(0, 80 * 2, 32 * 2, 32 * 2),
            sprites.subsurface(32 * 2, 80 * 2, 32 * 2, 32 * 2),
        ]

        self.state = self.STATE_ACTIVE

    def draw(self):
        global screen
        screen.blit(self.image, self.rect.topleft)

    def update(self):
        global players, enemies, labels, iron_blocks, castles, Babax, sad1, fad1, das1, player_health, win

        if self.direction == DIR_UP:
            self.rect.topleft = [self.rect.left, self.rect.top - self.speed]
            if self.rect.top < 0:
                if self.owner == OWNER_PLAYER:
                    sounds["steel"].play()
                # self.explode()
                self.power -= 1
                self.destroy()
                return
        elif self.direction == DIR_RIGHT:
            self.rect.topleft = [self.rect.left + self.speed, self.rect.top]
            if self.rect.left > (416 - self.rect.width):
                if self.owner == OWNER_PLAYER:
                    sounds["steel"].play()
                # self.explode()
                self.power -= 1
                self.destroy()
                return
        elif self.direction == DIR_DOWN:
            self.rect.topleft = [self.rect.left, self.rect.top + self.speed]
            if self.rect.top > (416 - self.rect.height):
                if self.owner == OWNER_PLAYER:
                    sounds["steel"].play()
                # self.explode()
                self.power -= 1
                self.destroy()
                return
        elif self.direction == DIR_LEFT:
            self.rect.topleft = [self.rect.left - self.speed, self.rect.top]
            if self.rect.left < 0:
                if self.owner == OWNER_PLAYER:
                    sounds["steel"].play()
                # self.explode()
                self.power -= 1
                self.destroy()
                return
        if self.owner != OWNER_ENEMY:
            for enemy in enemies:
                if self.rect.colliderect(enemy.rect):
                    sounds["steel"].play()
                    self.power -= 1
                    if self.power == 0:
                        self.destroy()
                    enemy.health -= 1
                    if enemy.health >= 1:
                        enemy.bullet = True
                    return

        # Коллизии с Tile'ми
        rects = Level0.obstacle_rects
        collisions = self.rect.collidelistall(rects)
        has_collided = False
        if collisions != []:
            for i in collisions:
                if Level0.hitTile(rects[i].topleft, self.power):
                    has_collided = True
        if has_collided:
            self.power -= 1
            if self.power == 0:
                self.destroy()
            return

        for castle in castles:
            if self.rect.colliderect(castle.rect):
                sounds["steel"].play()
                self.power -= 1
                if self.power == 0:
                    self.destroy()
                win = False
                castles.remove(castle)
                gameOver = GameOver()
                gameOver.draw(Game)
                return
        if self.owner != OWNER_PLAYER:
            for player in players:
                if self.rect.colliderect(player.rect):
                    sounds["steel"].play()
                    self.power -= 1
                    player.health -= 1
                    if player.health <= 50:
                        player_health.remove(player_health[sad1])
                    sad1 -= 1
                    if self.power == 0:
                        self.destroy()
                    if player.health == 0:
                        players.remove(player)
                        gameOver = GameOver()
                        gameOver.draw(Game)
                    return
        for enemy in enemies:
            for bullet in enemy.enemy_bullets:
                if self.rect.colliderect(bullet.rect) and self != bullet:
                    self.power -= 1
                    bullet.power -= 1
                    if self.power == 0:
                        self.destroy()
                    if bullet.power == 0:
                        bullet.destroy()
        # and self.direction != bullet.direction

    def destroy(self):
        Babax.append(Babaxs(self.rect[0] - 5, self.rect[1] - 50, 1))
        sounds["explosion"].play()
        self.state = self.STATE_REMOVED


class Block:
    def draw(self, sad):
        pass


class Castle(Block):
    """ Замок\флаг игрока, который надо защищять """

    def __init__(self):

        # Обращаемся к глобальной переменной sprites
        global sprites

        # Зададим изображения из списка спрайтов для целого
        self.img_undamaged = sprites.subsurface(0, 15 * 2, 16 * 2, 16 * 2)
        # и разрушенного замка\флага
        self.img_destroyed = sprites.subsurface(16 * 2, 15 * 2, 16 * 2, 16 * 2)

        # Определяем позицию ректангла, она всегда постоянная
        self.rect = pygame.Rect(12 * 16, 24 * 16, 30, 38)

    def draw(self, sad):
        """ Здесь рисуем наш замок \ флаг """
        global screen
        if sad == 1:
            screen.blit(self.img_undamaged, self.rect.topleft)
        if sad == 2:
            screen.blit(self.img_destroyed, self.rect.topleft)


class GameOver:

    def __init__(self):
        super().__init__()

    def draw(self, enemy):
        global running, win, Level0, nom, game, answer, running1
        pygame.init()  # Инициация PyGame, обязательная строчка
        screen = pygame.display.set_mode(DISPLAY)  # Создаем окошко
        bg = Surface((WIN_WIDTH, WIN_HEIGHT))  # Создание видимой поверхности, будем использовать как фон
        bg.fill(Color(BACKGROUND_COLOR))  # Заливаем поверхность сплошным цветом
        clock = pygame.time.Clock()
        # Цикл игры
        # Загружаем спрайты
        sprites = pygame.transform.scale(pygame.image.load("images/sprites.gif"), [192, 224])
        i_ = 0
        enemy.im_game_over = pygame.Surface((64, 40))
        # self.im_game_over.fill((0, 0, 0))
        enemy.font = pygame.font.Font("fonts/prstart.ttf", 16)
        enemy.im_game_over.set_colorkey((0, 0, 0))
        enemy.im_game_over.blit(enemy.font.render("GAME", False, (255, 0, 0)), [0, 0])
        enemy.im_game_over.blit(enemy.font.render("OVER", False, (255, 0, 0)), [0, 20])
        enemy.game_over_y = 416 + 40
        enemy.game_over = True
        clock = pygame.time.Clock()
        FPS = 30
        sad = True
        if running and running1:
            while sad and running1:
                clock.tick(FPS)
                for event in pygame.event.get():  # Обрабатываем события
                    if event.type == pygame.QUIT:  # Проверка закрытия окна
                        sad = False
                        running = False
                        running1 = False
                i_ = i_ + 1
                if enemy.game_over:
                    if i_ >= 50:
                        enemy.game_over = True
                    if enemy.game_over:
                        if enemy.game_over_y > 188:
                            enemy.game_over_y -= 4
                        screen.blit(enemy.im_game_over, [176, enemy.game_over_y])
                pygame.display.update()
                screen.blit(bg, (0, 0))
                if enemy.game_over_y <= 188:
                    sad = False
        win = False
        if running1 and running:
            menu = Answer()
            menu.draw()


class GameWin:

    def __init__(self):
        super().__init__()

    def draw(self, enemy):
        global running, nom, Level0, game, answer, running1
        pygame.init()  # Инициация PyGame, обязательная строчка
        screen = pygame.display.set_mode(DISPLAY)  # Создаем окошко
        bg = Surface((WIN_WIDTH, WIN_HEIGHT))  # Создание видимой поверхности, будем использовать как фон
        bg.fill(Color(BACKGROUND_COLOR))  # Заливаем поверхность сплошным цветом
        clock = pygame.time.Clock()
        # Цикл игры
        # Загружаем спрайты
        sprites = pygame.transform.scale(pygame.image.load("images/sprites.gif"), [192, 224])
        i_ = 0
        enemy.im_game_win = pygame.Surface((64, 40))
        # self.im_game_over.fill((0, 0, 0))
        enemy.font = pygame.font.Font("fonts/prstart.ttf", 16)
        enemy.im_game_win.set_colorkey((0, 0, 0))
        enemy.im_game_win.blit(enemy.font.render("GAME", False, (255, 200, 200)), [0, 0])
        enemy.im_game_win.blit(enemy.font.render("WIN", False, (255, 200, 200)), [0, 20])
        enemy.game_win_y = 416 + 40
        enemy.game_win = True
        clock = pygame.time.Clock()
        FPS = 30
        sad = True
        if running and running1:
            while sad and running1:
                clock.tick(FPS)
                for event in pygame.event.get():  # Обрабатываем события
                    if event.type == pygame.QUIT:  # Проверка закрытия окна
                        sad = False
                        running = False
                        running1 = False
                i_ = i_ + 1
                if enemy.game_win:
                    if i_ >= 50:
                        enemy.game_win = True
                    if enemy.game_win:
                        if enemy.game_win_y > 188:
                            enemy.game_win_y -= 4
                        screen.blit(enemy.im_game_win, [176, enemy.game_win_y])
                pygame.display.update()
                screen.blit(bg, (0, 0))
                if enemy.game_win_y <= 188:
                    sad = False
        if running1 and running:
            answer0 = Answer()
            answer0.draw()


class Answer:

    def __init__(self):
        super().__init__()

    def draw(self):
        global running, nom, Level0, game, answer, win, players, enemies, castles, amplifiers, protect_castle, \
            player_health, enemy_health, bonuses, labels, iron_blocks, water_blocks, enemies_nomber, shield1, shield0, \
            steel, steel_health, sto, das1, fad1, sad1, stop, star, Babax, EnemyBabaxs, running1, enemy_bullets
        pygame.init()  # Инициация PyGame, обязательная строчка
        screen = pygame.display.set_mode(DISPLAY)  # Создаем окошко
        bg = Surface((WIN_WIDTH, WIN_HEIGHT))  # Создание видимой поверхности, будем использовать как фон
        bg.fill(Color(BACKGROUND_COLOR))  # Заливаем поверхность сплошным цветом
        clock = pygame.time.Clock()
        # Цикл игры
        # Загружаем спрайты
        sprites = pygame.transform.scale(pygame.image.load("images/sprites.gif"), [192, 224])
        i_ = 0
        na = False
        if win:
            sad10 = textAria(100, 436, 0, 0, (255, 200, 200))
            sad10.set_text('Следуйщая игра?', sad10.color)
            na = True
        else:
            sad10 = textAria(180, 436, 0, 0, (255, 200, 250))
            sad10.set_text('Заново?', sad10.color)
        sad11 = textAria(150, 496, 50, 30, (255, 200, 250))
        sad11.set_text('Да', sad11.color)
        sad12 = textAria(270, 496, 60, 30, (255, 200, 250))
        sad12.set_text('Нет', sad12.color)
        das10 = True
        clock = pygame.time.Clock()
        FPS = 30
        sad = True
        gas = False
        had0 = 0
        if running and running1:
            while sad and running1:
                clock.tick(FPS)
                for event in pygame.event.get():  # Обрабатываем события
                    if event.type == pygame.QUIT:  # Проверка закрытия окна
                        sad = False
                        running = False
                        running1 = False
                    if event.type == pygame.MOUSEBUTTONDOWN:
                        x, y = event.pos
                        if sad11.collidepoint(x, y):
                            gas = True
                        elif sad12.collidepoint(x, y):
                            sad = False
                    if event.type == pygame.KEYDOWN:
                        if event.key == K_a or event.key == K_LEFT:
                            sad11.set_text('Да', (25, 255, 25))
                            sad12.set_text('Нет', (255, 255, 255))
                            had0 = 1
                        if event.key == K_d or event.key == K_RIGHT:
                            sad12.set_text('Нет', (25, 255, 25))
                            sad11.set_text('Да', (255, 255, 255))
                            had0 = 2
                        if event.key == K_SPACE:
                            if had0 == 1:
                                gas = True
                            elif had0 == 2:
                                sad = False
                if gas:
                    gas = False
                    running = True
                    protect_castle = []
                    players = []
                    enemies = []
                    player_health = []
                    enemy_health = []
                    enemy_bullets = []
                    castles = []
                    bonuses = []
                    labels = []
                    amplifiers = []
                    iron_blocks = []
                    water_blocks = []
                    Babax = []
                    EnemyBabaxs = []
                    shield1 = []
                    shield0 = False
                    win = True
                    steel = False
                    steel_health = 350
                    sto = 300
                    das1 = 425
                    fad1 = 100
                    sad1 = 0
                    stop = False
                    star = 0
                    if na:
                        nom += 1
                        Level0 = Level(nom)
                        enemies_nomber = nom + 5
                        if enemies_nomber > 30:
                            enemies_nomber = 30
                        if enemies_nomber > 40:
                            enemies_nomber = 40
                        game = Game()
                    else:
                        Level0 = Level(nom)
                        enemies_nomber = nom + 5
                        if enemies_nomber > 30:
                            enemies_nomber = 30
                        if enemies_nomber > 40:
                            enemies_nomber = 40
                        game = Game()
                i_ = i_ + 1
                if das10:
                    if i_ >= 50:
                        das10 = True
                    if das10:
                        if sad10.rect[1] > 188:
                            sad10.rect[1] -= 4
                        if sad11.rect[1] > 128:
                            sad11.rect[1] -= 4
                        if sad12.rect[1] > 128:
                            sad12.rect[1] -= 4
                sad10.draw()
                sad11.draw()
                sad12.draw()
                pygame.display.update()
                screen.blit(bg, (0, 0))
                if sad10.rect[1] <= 188:
                    das10 = False
            if running1:
                menu = Menu()
                menu.draw()


class Menu:

    def __init__(self):
        super().__init__()

    def draw(self):
        global running, nom, Level0, game, answer, win, players, enemies, castles, amplifiers, protect_castle, \
            player_health, enemy_health, bonuses, labels, iron_blocks, water_blocks, enemies_nomber, shield1, shield0, \
            steel, steel_health, sto, das1, fad1, sad1, stop, star, level_nom, running1, enemy_bullets, player_color, \
            Babax, EnemyBabaxs
        pygame.init()  # Инициация PyGame, обязательная строчка
        screen = pygame.display.set_mode(DISPLAY)  # Создаем окошко
        bg = Surface((WIN_WIDTH, WIN_HEIGHT))  # Создание видимой поверхности, будем использовать как фон
        bg.fill(Color(BACKGROUND_COLOR))  # Заливаем поверхность сплошным цветом
        clock = pygame.time.Clock()
        # Цикл игры
        # Загружаем спрайты
        sprites = pygame.transform.scale(pygame.image.load("images/sprites.gif"), [192, 224])
        level0 = []
        nombers0 = []
        nombers = []
        colors = []
        colors.append(Player((0, 255, 255), 100, -50))
        colors.append(Player((0, 0, 0), 150, -50))
        colors.append(Player((255, 255, 0), 200, -50))
        colors.append(Player((255, 0, 255), 250, -50))
        colors.append(Player((255, 0, 0), 300, -50))
        colors.append(Player((0, 0, 255), 350, -50))
        x = 50
        y = 50
        a = 0

        for q in range(11):
            level0.append(Flag(x, y, q))
            x += 80
            if x >= 400:
                x = 50
                y += 40
        for level1 in level0:
            nombers.append(textAria(level1.rect[0] + 35, level1.rect[1], 300, 100, (255, 255, 255)))

        for nomber in nombers:
            nomber.set_text(str(a), (255, 255, 255))
            a += 1

        x = 100
        for i in range(6):
            nombers0.append(textAria(x, -100, 300, 100, (255, 255, 255)))
            x += 50
            nombers0[i].set_text(str(i + 1), (255, 255, 255))
        clock = pygame.time.Clock()
        FPS = 30
        sad = True
        gas = False
        gas0 = False
        fas0 = False
        up = False
        down = False
        fas = False
        nom0 = '1'
        a = 0
        a0 = 0
        a1 = 0
        a2 = 50
        while sad and running1:
            clock.tick(FPS)
            for event in pygame.event.get():  # Обрабатываем события
                if event.type == pygame.QUIT:  # Проверка закрытия окна
                    sad = False
                    running = False
                    running1 = False
                if event.type == pygame.MOUSEBUTTONDOWN:
                    x, y = event.pos
                    for level1 in level0:
                        if level1.collidepoint(x, y):
                            gas = True
                            nom = level1.sad
                if event.type == pygame.KEYDOWN:
                    if event.key == K_a or event.key == K_LEFT:
                        fas = True
                    elif event.key == K_d or event.key == K_RIGHT:
                        fas0 = True
                    elif event.key == K_w or event.key == K_UP:
                        up = True
                    elif event.key == K_s or event.key == K_DOWN:
                        down = True
                    elif event.key == K_SPACE:
                        gas = True
                        gas0 = True
                if event.type == pygame.KEYUP:
                    if event.key == K_w or event.key == K_UP:
                        up = False
                    if event.key == K_s or event.key == K_DOWN:
                        down = False
                    if event.key == K_a or event.key == K_LEFT:
                        fas = False
                    if event.key == K_d or event.key == K_RIGHT:
                        fas0 = False
                    if event.key == K_SPACE:
                        gas = False

            for nomber in nombers:
                if int(nomber.text0) <= level_nom:
                    nomber.set_text(nomber.text0, (255, 255, 255))
                if str(nom) == nomber.text0:
                    nomber.set_text(nomber.text0, (50, 255, 50))
                if int(nomber.text0) > level_nom:
                    nomber.set_text(nomber.text0, (174, 174, 174))
            for nomber in nombers0:
                if nom == -1 * int(nomber.text0) + 1:
                    nomber.set_text(nomber.text0, (50, 255, 50))
                else:
                    nomber.set_text(nomber.text0, (255, 255, 255))

            for nomber in nombers0:
                if nom0 == nomber.text0:
                    nomber.set_text(nomber.text0, (0, 0, 255))

            if up and nombers[0].rect[1] <= 150:
                for nomber in nombers:
                    nomber.rect[1] += 5
                for level1 in level0:
                    level1.rect[1] += 5
                for color0 in colors:
                    color0.rect[1] += 5
                for nomber in nombers0:
                    nomber.rect[1] += 5
            if down and nombers[-1].rect[1] >= 100:
                for nomber in nombers:
                    nomber.rect[1] -= 5
                for level1 in level0:
                    level1.rect[1] -= 5
                for color0 in colors:
                    color0.rect[1] -= 5
                for nomber in nombers0:
                    nomber.rect[1] -= 5
            for level1 in level0:
                level1.draw()
            for nomber in nombers:
                nomber.draw()
            for nomber in nombers0:
                nomber.draw()
            for color0 in colors:
                color0.draw()
            if nom != -6 and fas and a == 0:
                nom -= 1
                a = 5
            if nom != 11 and nom != level_nom and fas0 and a0 == 0:
                nom += 1
                a0 = 5
            if a != 0:
                a -= 1
            if a0 != 0:
                a0 -= 1
            if gas and nom >= 0:
                running = True
                protect_castle = []
                players = []
                enemies = []
                player_health = []
                enemy_health = []
                enemy_bullets = []
                castles = []
                bonuses = []
                Babax = []
                EnemyBabaxs = []
                labels = []
                amplifiers = []
                iron_blocks = []
                water_blocks = []
                shield1 = []
                shield0 = False
                win = True
                steel = False
                steel_health = 350
                sto = 300
                das1 = 425
                fad1 = 100
                sad1 = 0
                stop = False
                star = 0
                Level0 = Level(nom)
                enemies_nomber = nom + 5
                if enemies_nomber > 30:
                    enemies_nomber = 30
                if enemies_nomber > 40:
                    enemies_nomber = 40
                if nom == 0:
                    game = Game0()
                else:
                    game = Game()
            elif gas and nom < 0 and a1 <= 0:
                if nom == 0:
                    player_color = (0, 255, 255)
                if nom == -1:
                    player_color = (0, 0, 0)
                if nom == -2:
                    player_color = (255, 255, 0)
                if nom == -3:
                    player_color = (255, 0, 255)
                if nom == -4:
                    player_color = (255, 0, 0)
                if nom == -5:
                    player_color = (0, 0, 255)
                for nomber in nombers0:
                    if -int(nomber.text0) + 1 == nom:
                        nom0 = nomber.text0
            if a1 > 0:
                a1 -= 1

            pygame.display.update()
            screen.blit(bg, (0, 0))
        running = False


class myRect(pygame.Rect):
    def __init__(self, left, top, width, height, type):
        self.rect = pygame.Rect.__init__(self, left, top, width, height)
        self.type = type


class Level:
    def __init__(self, level_nr=None):
        global sprites

        tile_images = [
            pygame.Surface((8 * 2, 8 * 2)),
            sprites.subsurface(48 * 2, 64 * 2, 8 * 2, 8 * 2),
            sprites.subsurface(48 * 2, 72 * 2, 8 * 2, 8 * 2),
            sprites.subsurface(56 * 2, 72 * 2, 8 * 2, 8 * 2),
            sprites.subsurface(64 * 2, 64 * 2, 8 * 2, 8 * 2),
            sprites.subsurface(64 * 2, 64 * 2, 8 * 2, 8 * 2),
            sprites.subsurface(72 * 2, 64 * 2, 8 * 2, 8 * 2),
            sprites.subsurface(64 * 2, 72 * 2, 8 * 2, 8 * 2)
        ]
        self.tile_empty = tile_images[0]
        self.tile_brick = tile_images[1]
        self.tile_steel = tile_images[2]
        self.tile_grass = tile_images[3]
        self.tile_water = tile_images[4]
        self.tile_water1 = tile_images[4]
        self.tile_water2 = tile_images[5]
        self.tile_froze = tile_images[6]
        self.mapr = []
        self.mapr_grass = []

        level_nr = 1 if level_nr is None else level_nr % 11

        self.loadLevel(level_nr)

        # tiles' rects on map, tanks cannot move over
        self.obstacle_rects = []

        # update these tiles
        self.updateObstacleRects()

    def hitTile(self, pos, power=1):
        global sounds

        for tile in self.mapr:
            if tile.topleft == pos:
                if tile.type == TILE_BRICK:
                    sounds["brick"].play()
                    self.mapr.remove(tile)
                    self.updateObstacleRects()
                    return True
                elif tile.type == TILE_STEEL:
                    sounds["steel"].play()
                    if power == 2:
                        self.mapr.remove(tile)
                        self.updateObstacleRects()
                    return True
                else:
                    return False

    def toggleWaves(self):
        """ Toggle water image """
        if self.tile_water == self.tile_water1:
            self.tile_water = self.tile_water2
        else:
            self.tile_water = self.tile_water1

    def loadLevel(self, level_nr=1):
        filename = "tank_levels/" + str(level_nr)
        if not os.path.isfile(filename):
            return False
        f = open(filename, "r")
        data = f.read().split("\n")
        self.mapr = []
        self.mapr_grass = []
        x, y = 0, 0
        for row in data:
            for ch in row:
                if ch == "#":
                    self.mapr.append(myRect(x, y, TILE_SIZE, TILE_SIZE, TILE_BRICK))
                elif ch == "@":
                    self.mapr.append(myRect(x, y, TILE_SIZE, TILE_SIZE, TILE_STEEL))
                elif ch == "~":
                    self.mapr.append(myRect(x, y, TILE_SIZE, TILE_SIZE, TILE_WATER))
                elif ch == "%":
                    self.mapr_grass.append(myRect(x, y, TILE_SIZE, TILE_SIZE, TILE_GRASS))
                elif ch == "-":
                    self.mapr.append(myRect(x, y, TILE_SIZE, TILE_SIZE, TILE_FROZE))
                x += TILE_SIZE
            x = 0
            y += TILE_SIZE
        return True

    def draw(self, tiles=None):
        global screen

        if tiles is None:
            tiles = [TILE_BRICK, TILE_STEEL, TILE_WATER, TILE_GRASS, TILE_FROZE]

        for tile in self.mapr:
            if tile.type in tiles:
                if tile.type == TILE_BRICK:
                    screen.blit(self.tile_brick, tile.topleft)
                elif tile.type == TILE_STEEL:
                    screen.blit(self.tile_steel, tile.topleft)
                elif tile.type == TILE_WATER:
                    screen.blit(self.tile_water, tile.topleft)
                elif tile.type == TILE_FROZE:
                    screen.blit(self.tile_froze, tile.topleft)
                elif tile.type == TILE_GRASS:
                    screen.blit(self.tile_grass, tile.topleft)

    def updateObstacleRects(self):
        self.obstacle_rects = []
        for tile in self.mapr:
            if tile.type in (TILE_BRICK, TILE_STEEL, TILE_WATER):
                self.obstacle_rects.append(tile)


class Game0:
    def __init__(self):
        global screen, sprites, sounds, had, labels, amplifiers, running, stop, shield0, steel_health, steel, sto, das1, \
            fad1, sad1, font1, nom, enemies_nomber, answer, win, running1, level_nom, die
        pygame.init()  # Инициация PyGame, обязательная строчка
        screen = pygame.display.set_mode(DISPLAY)  # Создаем окошко
        pygame.display.set_caption("My Game")  # Пишем в шапку
        bg = Surface((WIN_WIDTH, WIN_HEIGHT))  # Создание видимой поверхности, будем использовать как фон
        bg.fill(Color(BACKGROUND_COLOR))  # Заливаем поверхность сплошным цветом
        clock = pygame.time.Clock()
        # Цикл игры
        # Загружаем спрайты
        sprites = pygame.transform.scale(pygame.image.load("images/sprites.gif"), [192, 224])
        sprites1 = pygame.transform.scale(pygame.image.load("images/grey.jpg"), [192, 600])
        # Делаем объект замка\флага
        castle = Castle()
        castles.append(castle)
        player = Player(player_color, 8 * 16, 24 * 16)
        players.append(player)
        das = 425
        fad = 150
        d = 0
        for i in range(enemies_nomber):
            if i % 3 == 0 and i != 0:
                fad += 18
                das = 425
            enemy_health.append(Enemy_health(das, fad))
            das += 18

        for i in range(player.health):
            if i % 3 == 0 and i != 0:
                fad1 += 18
                das1 = 425
                # sad1 += 1
            player_health.append(Player_health(das1, fad1))
            das1 += 18
        flag = Flag(420, 15, 1)
        nomber = textAria(455, 15, 300, 100, (255, 255, 255))
        nomber.set_text(str(nom), (255, 255, 255))
        back_ground_grey.append(Back_ground_grey(415, 0))

        # Создаем переменную которая хранит звук начала игры
        sound_start = pygame.mixer.Sound("sounds/gamestart.ogg")
        # Инициализируем миксер для проигрывания звука
        pygame.mixer.pre_init(44100, -16, 1, 512)
        # Создаем переменную которая хранит звук начала игры
        sound_start = pygame.mixer.Sound("sounds/gamestart.ogg")
        ##############################################################################################################
        self.game_over = False
        self.game_win = False

        # Иконка окна игры
        pygame.display.set_icon(sprites.subsurface(0, 0, 13 * 2, 13 * 2))
        # Загрузим все звуки в один словарь
        # Загрузим все звуки в один словарь
        sounds["start"] = pygame.mixer.Sound("sounds/gamestart.ogg")
        # Загрузим шрифт похожий на оригинальный
        self.font = pygame.font.Font("fonts/prstart.ttf", 16)

        sounds["end"] = pygame.mixer.Sound("sounds/gameover.ogg")
        sounds["score"] = pygame.mixer.Sound("sounds/score.ogg")
        sounds["bg"] = pygame.mixer.Sound("sounds/background.ogg")
        sounds["fire"] = pygame.mixer.Sound("sounds/fire.ogg")
        sounds["bonus"] = pygame.mixer.Sound("sounds/bonus.ogg")
        sounds["explosion"] = pygame.mixer.Sound("sounds/explosion.ogg")
        sounds["brick"] = pygame.mixer.Sound("sounds/brick.ogg")
        sounds["steel"] = pygame.mixer.Sound("sounds/steel.ogg")
        ########################################################################
        # Сделаем пререндер окна с окончанием игры
        gameOver = GameOver()
        gameWin = GameWin()
        ########################################################################
        # Задаём проверочную переменную для цикла
        play_sound_start = True
        ampl = 200
        e = 0
        a = 1
        sh = -1
        i_ = 0
        gad1 = 3
        right = False
        left = False
        up = False
        down = False
        gad = False
        shot = False
        star0 = True
        star1 = True
        health = 1
        sto = 300
        direction_player = STOP
        sad10 = textAria(0, 50, 0, 0, (255, 200, 200))
        sad10.set_text('Управление - стрелками', (255, 255, 255))
        sad9 = textAria(0, 85, 0, 0, (255, 200, 200))
        sad9.set_text('или клавишами WASD', (255, 255, 255))
        sad11 = textAria(0, 150, 0, 0, (255, 200, 200))
        sad11.set_text('Стрельба или переход', (255, 255, 255))
        sad12 = textAria(0, 185, 0, 0, (255, 200, 200))
        sad12.set_text('в новое окно - пробелом', (255, 255, 255))
        z = True
        f = True
        while running and running1:  # Основной цикл программы
            # Держим цикл на правильной скорости
            clock.tick(FPS)
            # Ввод процесса (события)
            for event in pygame.event.get():  # Обрабатываем события
                if event.type == pygame.QUIT:  # Проверка закрытия окна
                    running = False
                    running1 = False
                if event.type == pygame.KEYDOWN:
                    if event.key == K_RIGHT or event.key == K_d:
                        direction_player = DIR_RIGHT
                        z = False
                    elif event.key == K_LEFT or event.key == K_a:
                        direction_player = DIR_LEFT
                        z = False
                    elif event.key == K_UP or event.key == K_w:
                        direction_player = DIR_UP
                        z = False
                    elif event.key == K_DOWN or event.key == K_s:
                        direction_player = DIR_DOWN
                        z = False
                    elif event.key == K_SPACE:
                        for player in players:
                            if not player.player_bullets:
                                shot = True
                                gad = True
                        f = False
                elif event.type == pygame.KEYUP:
                    if event.key == K_RIGHT or event.key == K_d:
                        direction_player = STOP
                    elif event.key == K_LEFT or event.key == K_a:
                        direction_player = STOP
                    elif event.key == K_UP or event.key == K_w:
                        direction_player = STOP
                    elif event.key == K_DOWN or event.key == K_s:
                        direction_player = STOP
                    if event.key == K_SPACE:
                        shot = False
                        gad = False
            # Обновление
            if len(enemies) < 3 and enemies_nomber != 0:
                for i in range(3 - len(enemies)):
                    if e == 0 or enemies_nomber > 18:
                        w = randint(0, 4)
                        if a == 1 and enemies_nomber != 0:
                            if w != 4:
                                enemies.append(EnemyTank(0, 0, (255, 255, 255), 3, randint(1, 4)))
                            else:
                                enemies.append(EnemyTank(0, 0, (255, 255, 255), 3, randint(5, 8)))
                            enemies_nomber -= 1
                        elif a == 2 and enemies_nomber != 0:
                            if w != 4:
                                enemies.append(EnemyTank(12.3 * 16, 0, (255, 255, 255), 3, randint(1, 4)))
                            else:
                                enemies.append(EnemyTank(12.3 * 16, 0, (255, 255, 255), 3, randint(5, 8)))
                            enemies_nomber -= 1
                        elif a == 3 and enemies_nomber != 0:
                            if w != 4:
                                enemies.append(EnemyTank(20 * 16, 0, (255, 255, 255), 3, randint(1, 4)))
                            else:
                                enemies.append(EnemyTank(20 * 16, 0, (255, 255, 255), 3, randint(5, 8)))
                            enemies_nomber -= 1
                        else:
                            a = 0
                        a += 1
                        e = 75
                    else:
                        e -= 1
            if play_sound_start:
                sound_start.play()
                play_sound_start = False
            if player.update(direction_player):
                sounds["bg"].stop()
                sounds["bg"].play()
            if shot:
                player.fire()
                sounds["fire"].play()
            # for enemy in enemies:
            #     enemy.update()
            for player in players:
                for bullet in player.player_bullets:
                    if bullet.state == bullet.STATE_REMOVED:
                        player.player_bullets.remove(bullet)
                    else:
                        bullet.update()
            for enemy in enemies:
                for bullet in enemy.enemy_bullets:
                    if bullet.state == bullet.STATE_REMOVED:
                        enemy.enemy_bullets.remove(bullet)
                    else:
                        bullet.update()
            # Рендеринг
            screen.blit(bg, (0, 0))  # Каждую итерацию необходимо всё перерисовывать
            # noinspection PyUnboundLocalVariable
            for bac in back_ground_grey:
                bac.draw()
            for enemy in enemies:
                if enemy.s == 0 and enemy.speed != 0:
                    enemy.a = randint(1, 7)
                    if enemy.a < 5:
                        enemy.s = randint(16, 48)
                if enemy.a == 1:
                    enemy.update(DIR_RIGHT)
                elif enemy.a == 2:
                    enemy.update(DIR_LEFT)
                elif enemy.a == 3:
                    enemy.update(DIR_UP)
                elif enemy.a == 4:
                    enemy.update(DIR_DOWN)
                else:
                    enemy.update(5)

            Level0.draw()

            for enemy in enemies:
                if enemy.sad == 4 or enemy.sad == 8:
                    enemy.colors()
                enemy.draw()

            for enemy in enemy_health:
                enemy.draw()
            for enemy in enemies:
                if enemy.health <= 0:
                    EnemyBabaxs.append(EnemyBabax(enemy.rect[0], enemy.rect[1], 2))
                    enemies.remove(enemy)
                    if enemy.sad > 4:
                        amplifiers.append(Bonus())
                    for bullet in enemy.enemy_bullets:
                        enemy_bullets.append(bullet)
                    enemy_health.remove(enemy_health[d])

            for babax in Babax:
                babax.draw()

            for babax in EnemyBabaxs:

                if babax.health <= 0:
                    EnemyBabaxs.remove(babax)
                else:
                    babax.health -= 1
                babax.update(babax.health)
                babax.draw()

            if self.game_over:
                break

            if self.game_win:
                if nom == level_nom:
                    level_nom += 1
                break

            if not players:
                self.game_over = True

            if not enemies and enemies_nomber == 0:
                self.game_win = True

            for castle in castles:
                castle.draw(1)

            for tile in Level0.mapr_grass:
                screen.blit(Level0.tile_grass, tile.topleft)

            flag.draw()
            nomber.draw()
            if z:
                sad10.draw()
                sad9.draw()
            if f:
                sad11.draw()
                sad12.draw()

            for player in players:
                player.draw()

            for pla in player_health:
                pla.draw()

            for enemy in enemies:
                for bullet in enemy.enemy_bullets:
                    bullet.draw()

            for bullet in enemy_bullets:
                bullet.update()
                bullet.draw()
                if bullet.power <= 0:
                    Babax.append(Babaxs(bullet.rect[0] - 5, bullet.rect[1] - 50, 1))
                    sounds["explosion"].play()
                    enemy_bullets.remove(bullet)

            for player in players:
                for bullet in player.player_bullets:
                    bullet.draw()

            for player in players:
                if player.player_bullets:
                    shot = False
            if gad:
                for player in players:
                    if not player.player_bullets and not gad1:
                        shot = True
                        gad1 = 3
                    elif gad1 > 0:
                        gad1 -= 1
            #####################################################
            # После отрисовки всего, переворачиваем экран
            pygame.display.update()  # обновление и вывод всех изменений на экран

            for babax in Babax:
                if babax.health <= 0:
                    Babax.remove(babax)
                else:
                    babax.health -= 1
            pygame.display.flip()
        if running1:
            if self.game_over:
                gameOver.draw(Game)
            if self.game_win:
                gameWin.draw(Game)


class Game:
    # Константы отвечающие за направление движения
    # (DIR_UP, DIR_RIGHT, DIR_DOWN, DIR_LEFT) = range(4)
    # Размер плитки (для рисования карты)
    # TILE_SIZE = 16

    def __init__(self):
        global screen, sprites, sounds, had, labels, amplifiers, running, stop, shield0, steel_health, steel, sto, das1, \
            fad1, sad1, font1, nom, enemies_nomber, answer, win, running1, level_nom, die
        pygame.init()  # Инициация PyGame, обязательная строчка
        screen = pygame.display.set_mode(DISPLAY)  # Создаем окошко
        pygame.display.set_caption("My Game")  # Пишем в шапку
        bg = Surface((WIN_WIDTH, WIN_HEIGHT))  # Создание видимой поверхности, будем использовать как фон
        bg.fill(Color(BACKGROUND_COLOR))  # Заливаем поверхность сплошным цветом
        clock = pygame.time.Clock()
        # Цикл игры
        # Загружаем спрайты
        sprites = pygame.transform.scale(pygame.image.load("images/sprites.gif"), [192, 224])
        sprites1 = pygame.transform.scale(pygame.image.load("images/grey.jpg"), [192, 600])
        # Делаем объект замка\флага
        castle = Castle()
        castles.append(castle)
        player = Player(player_color, 8 * 16, 24 * 16)
        players.append(player)
        das = 425
        fad = 150
        d = 0
        for i in range(enemies_nomber):
            if i % 3 == 0 and i != 0:
                fad += 18
                das = 425
            enemy_health.append(Enemy_health(das, fad))
            das += 18

        for i in range(player.health):
            if i % 3 == 0 and i != 0:
                fad1 += 18
                das1 = 425
                # sad1 += 1
            player_health.append(Player_health(das1, fad1))
            das1 += 18
        flag = Flag(420, 15, 1)
        nomber = textAria(455, 15, 300, 100, (255, 255, 255))
        nomber.set_text(str(nom), (255, 255, 255))
        back_ground_grey.append(Back_ground_grey(415, 0))

        # Создаем переменную которая хранит звук начала игры
        sound_start = pygame.mixer.Sound("sounds/gamestart.ogg")
        # Инициализируем миксер для проигрывания звука
        pygame.mixer.pre_init(44100, -16, 1, 512)
        # Создаем переменную которая хранит звук начала игры
        sound_start = pygame.mixer.Sound("sounds/gamestart.ogg")
        ##############################################################################################################
        self.game_over = False
        self.game_win = False

        # Иконка окна игры
        pygame.display.set_icon(sprites.subsurface(0, 0, 13 * 2, 13 * 2))
        # Загрузим все звуки в один словарь
        # Загрузим все звуки в один словарь
        sounds["start"] = pygame.mixer.Sound("sounds/gamestart.ogg")
        # Загрузим шрифт похожий на оригинальный
        self.font = pygame.font.Font("fonts/prstart.ttf", 16)

        sounds["end"] = pygame.mixer.Sound("sounds/gameover.ogg")
        sounds["score"] = pygame.mixer.Sound("sounds/score.ogg")
        sounds["bg"] = pygame.mixer.Sound("sounds/background.ogg")
        sounds["fire"] = pygame.mixer.Sound("sounds/fire.ogg")
        sounds["bonus"] = pygame.mixer.Sound("sounds/bonus.ogg")
        sounds["explosion"] = pygame.mixer.Sound("sounds/explosion.ogg")
        sounds["brick"] = pygame.mixer.Sound("sounds/brick.ogg")
        sounds["steel"] = pygame.mixer.Sound("sounds/steel.ogg")
        ########################################################################
        # Сделаем пререндер окна с окончанием игры
        gameOver = GameOver()
        gameWin = GameWin()
        ########################################################################
        # Задаём проверочную переменную для цикла
        play_sound_start = True
        ampl = 200
        e = 0
        a = 1
        sh = -1
        i_ = 0
        gad1 = 3
        right = False
        left = False
        up = False
        down = False
        gad = False
        shot = False
        star0 = True
        star1 = True
        health = 1
        sto = 300
        direction_player = STOP
        while running and running1:  # Основной цикл программы
            # Держим цикл на правильной скорости
            clock.tick(FPS)
            # Ввод процесса (события)
            for event in pygame.event.get():  # Обрабатываем события
                if event.type == pygame.QUIT:  # Проверка закрытия окна
                    running = False
                    running1 = False
                if event.type == pygame.KEYDOWN:
                    if event.key == K_RIGHT or event.key == K_d:
                        direction_player = DIR_RIGHT
                    elif event.key == K_LEFT or event.key == K_a:
                        direction_player = DIR_LEFT
                    elif event.key == K_UP or event.key == K_w:
                        direction_player = DIR_UP
                    elif event.key == K_DOWN or event.key == K_s:
                        direction_player = DIR_DOWN
                    elif event.key == K_SPACE:
                        for player in players:
                            if not player.player_bullets:
                                shot = True
                                gad = True
                elif event.type == pygame.KEYUP:
                    if event.key == K_RIGHT or event.key == K_d:
                        direction_player = STOP
                    elif event.key == K_LEFT or event.key == K_a:
                        direction_player = STOP
                    elif event.key == K_UP or event.key == K_w:
                        direction_player = STOP
                    elif event.key == K_DOWN or event.key == K_s:
                        direction_player = STOP
                    if event.key == K_SPACE:
                        shot = False
                        gad = False
            # Обновление
            if len(enemies) < 3 and enemies_nomber != 0:
                for i in range(3 - len(enemies)):
                    if e == 0 or enemies_nomber > 18:
                        w = randint(0, 4)
                        if a == 1 and enemies_nomber != 0:
                            if w != 4:
                                enemies.append(EnemyTank(0, 0, (255, 255, 255), 3, randint(1, 4)))
                            else:
                                enemies.append(EnemyTank(0, 0, (255, 255, 255), 3, randint(5, 8)))
                            enemies_nomber -= 1
                        elif a == 2 and enemies_nomber != 0:
                            if w != 4:
                                enemies.append(EnemyTank(12.3 * 16, 0, (255, 255, 255), 3, randint(1, 4)))
                            else:
                                enemies.append(EnemyTank(12.3 * 16, 0, (255, 255, 255), 3, randint(5, 8)))
                            enemies_nomber -= 1
                        elif a == 3 and enemies_nomber != 0:
                            if w != 4:
                                enemies.append(EnemyTank(20 * 16, 0, (255, 255, 255), 3, randint(1, 4)))
                            else:
                                enemies.append(EnemyTank(20 * 16, 0, (255, 255, 255), 3, randint(5, 8)))
                            enemies_nomber -= 1
                        else:
                            a = 0
                        a += 1
                        e = 75
                    else:
                        e -= 1
            if play_sound_start:
                sound_start.play()
                play_sound_start = False
            if player.update(direction_player):
                sounds["bg"].stop()
                sounds["bg"].play()
            if shot:
                player.fire()
                sounds["fire"].play()
            # for enemy in enemies:
            #     enemy.update()
            for player in players:
                for bullet in player.player_bullets:
                    if bullet.state == bullet.STATE_REMOVED:
                        player.player_bullets.remove(bullet)
                    else:
                        bullet.update()
            for enemy in enemies:
                for bullet in enemy.enemy_bullets:
                    if bullet.state == bullet.STATE_REMOVED:
                        enemy.enemy_bullets.remove(bullet)
                    else:
                        bullet.update()
            # Рендеринг
            screen.blit(bg, (0, 0))  # Каждую итерацию необходимо всё перерисовывать
            # noinspection PyUnboundLocalVariable
            for bac in back_ground_grey:
                bac.draw()

            for enemy in enemies:
                if enemy.s == 0 and enemy.speed != 0:
                    enemy.a = randint(1, 7)
                    if enemy.a < 5:
                        enemy.s = randint(16, 48)
                if enemy.a == 1:
                    enemy.update(DIR_RIGHT)
                elif enemy.a == 2:
                    enemy.update(DIR_LEFT)
                elif enemy.a == 3:
                    enemy.update(DIR_UP)
                elif enemy.a == 4:
                    enemy.update(DIR_DOWN)
                else:
                    enemy.update(5)

            Level0.draw()

            for enemy in enemies:
                if enemy.sad == 4 or enemy.sad == 8:
                    enemy.colors()
                enemy.draw()

            for enemy in enemy_health:
                enemy.draw()
            if stop:
                for enemy in enemies:
                    enemy.speed = 0
                sto -= 1
                if sto <= 0:
                    stop = False
                    sto = 300
                    for enemy in enemies:
                        enemy.speed = 3

            for enemy in enemies:
                if enemy.health <= 0:
                    EnemyBabaxs.append(EnemyBabax(enemy.rect[0], enemy.rect[1], 2))
                    enemies.remove(enemy)
                    if enemy.sad > 4:
                        amplifiers.append(Bonus())
                    for bullet in enemy.enemy_bullets:
                        enemy_bullets.append(bullet)
                    enemy_health.remove(enemy_health[d])

            for babax in Babax:
                babax.draw()

            for babax in EnemyBabaxs:

                if babax.health <= 0:
                    EnemyBabaxs.remove(babax)
                else:
                    babax.health -= 1
                babax.update(babax.health)
                babax.draw()

            if self.game_over:
                break

            if self.game_win:
                if nom == level_nom:
                    level_nom += 1
                break

            if die:
                for enemy in enemies:
                    enemy.health -= 1
                die = False

            for castle in castles:
                castle.draw(1)

            flag.draw()
            nomber.draw()

            for player in players:
                player.draw()

            for pla in player_health:
                pla.draw()

            for play in players:
                for shie in shield1:
                    shie.rect = play.rect

            for shie in shield1:
                shie.update()
                shie.draw()

            if not players:
                self.game_over = True

            if not enemies and enemies_nomber == 0:
                self.game_win = True

            # if not amplifiers:
            #      if ampl == 0:
            #         amplifiers.append(Bonus())
            #         ampl = 200
            #     else:
            #         ampl -= 1

            if shield0:
                for play in players:
                    shield1.append(Shild(play.rect[1], play.rect[0], 1))
                    health = play.health
                    play.health = 1000
                    shield0 = False
                    sh = 150
            if sh == 0:
                for play in players:
                    play.health = health
                for shie in shield1:
                    shield1.remove(shie)
            if sh != -1:
                sh -= 1

            if star == 1 and star0:
                for play in players:
                    play.bullet_speed += 2
                star0 = False
            if star == 2 and star1:
                for play in players:
                    play.bullets_power += 1
                star1 = False

            if steel:
                steel_health -= 1

            if not steel_health:
                steel_health = 350
                steel = False
                for castle in castles:
                    Level0.mapr.remove(myRect(castle.rect[0] - 16, castle.rect[1], 8, 8, TILE_STEEL))
                    Level0.mapr.remove(myRect(castle.rect[0] - 16, castle.rect[1] + 16, 8, 8, TILE_STEEL))
                    Level0.mapr.remove(myRect(castle.rect[0] - 16, castle.rect[1] - 16, 8, 8, TILE_STEEL))

                    Level0.mapr.remove(myRect(castle.rect[0] + 32, castle.rect[1], 8, 8, TILE_STEEL))
                    Level0.mapr.remove(myRect(castle.rect[0] + 32, castle.rect[1] + 16, 8, 8, TILE_STEEL))
                    Level0.mapr.remove(myRect(castle.rect[0] + 32, castle.rect[1] - 16, 8, 8, TILE_STEEL))

                    Level0.mapr.remove(myRect(castle.rect[0] + 16, castle.rect[1] - 16, 8, 8, TILE_STEEL))
                    Level0.mapr.remove(myRect(castle.rect[0], castle.rect[1] - 16, 8, 8, TILE_STEEL))

            for tile in Level0.mapr_grass:
                screen.blit(Level0.tile_grass, tile.topleft)

            for enemy in enemies:
                for bullet in enemy.enemy_bullets:
                    bullet.draw()

            for bullet in enemy_bullets:
                bullet.update()
                bullet.draw()
                if bullet.power <= 0:
                    Babax.append(Babaxs(bullet.rect[0] - 5, bullet.rect[1] - 50, 1))
                    sounds["explosion"].play()
                    enemy_bullets.remove(bullet)

            for player in players:
                for bullet in player.player_bullets:
                    bullet.draw()

            for amplifier in amplifiers:
                amplifier.draw()

            # screen.fill(BACKGROUND_COLOR)
            #####################################################
            for player in players:
                if player.player_bullets:
                    shot = False
            if gad:
                for player in players:
                    if not player.player_bullets and not gad1:
                        shot = True
                        gad1 = 3
                    elif gad1 > 0:
                        gad1 -= 1
            #####################################################
            # После отрисовки всего, переворачиваем экран
            pygame.display.update()  # обновление и вывод всех изменений на экран

            for babax in Babax:
                if babax.health <= 0:
                    Babax.remove(babax)
                else:
                    babax.health -= 1
            pygame.display.flip()
        if running1:
            if self.game_over:
                gameOver.draw(Game)
            if self.game_win:
                gameWin.draw(Game)
        # pygame.quit()


pygame.init()  # Инициация PyGame, обязательная строчка

# Инициализируем миксер для проигрывания звука
pygame.mixer.init()
pygame.mixer.pre_init(44100, -16, 1, 512)
pygame.display.set_caption("My Game!!!")  # Пишем в шапку
bg = Surface((WIN_WIDTH, WIN_HEIGHT))  # Создание видимой поверхности, будем использовать как фон
bg.fill(Color(BACKGROUND_COLOR))  # Заливаем поверхность сплошным цветом
font1 = pygame.font.Font(None, 50)
clock = pygame.time.Clock()
sprites = pygame.transform.scale(pygame.image.load("images/sprites.gif"), [192, 224])
sprites1 = pygame.transform.scale(pygame.image.load("images/grey.jpg"), [192, 600])
screen = pygame.display.set_mode(DISPLAY)
nom = 0
level_nom = 0
running1 = True
# while running1:
if __name__ == "__main__":
    running = True
    protect_castle = []
    player_color = (0, 255, 255)
    players = []
    die = False
    enemies = []
    player_health = []
    back_ground_grey = []
    enemy_health = []
    enemy_bullets = []
    Babax = []
    EnemyBabaxs = []
    castles = []
    bonuses = []
    labels = []
    answer = ''
    amplifiers = []
    iron_blocks = []
    water_blocks = []
    Level0 = Level(nom)
    enemies_nomber = nom + 5
    if enemies_nomber > 30:
        enemies_nomber = 30
    if enemies_nomber > 40:
        enemies_nomber = 40
    shield1 = []
    shield0 = False
    win = True
    steel = False
    steel_health = 350
    sto = 300
    das1 = 425
    fad1 = 100
    sad1 = 0
    stop = False
    star = 0
    sounds = {}
    game = Game0()
    game = Game()
